<!-- -*- mode: markdown; mode: flyspell -*- -->

# RPA: Remote Place Assigner

Built in a rush in march 2020 to support distance learning at the TU
Wien. With release version 0.2 all hardcoded TU settings have been
removed.

This is the client part. It consists of a callable program for users
or other programs called `rpa` and a host agent which does generic
work on hosts where places are located.

## host-agent protocol

The host agent is a script to be called via SSH by rapd and calls one
or more hooks. Optionally hooks can return variables.

### rpad to host agent protocol

| command | synopsis                | description                          |
| ------- | ----------------------- | ------------------------------------ |
| M       | M dir/hook [args..]     | call mandatory hook (must not fail)  |
| O       | O dir/hook [args..]     | call optional hook (can fail)        |
| P       | P                       | ping (nop)                           |
| Q       | Q                       | quit                                 |

### host agent to rpad protocol

| command | synopsis                | description                          |
| ------- | ----------------------- | ------------------------------------ |
| E       | E src msg               | error message                        |
| R       | R code                  | result code                          |
| V       | V name content          | return variable                      |
| W       | W src msg               | warning message                      |

result codes are:

| code | description                |
| ---- | -------------------------- |
| 0    | success                    |
| 1    | mandatory hook failed      |
| 2    | protocol error             |
| 3    | host-agent error           |
